import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.GameCanvas;
import javax.microedition.lcdui.game.LayerManager;
import javax.microedition.lcdui.game.Sprite;
import javax.microedition.lcdui.game.TiledLayer;
import javax.microedition.media.Manager;
import javax.microedition.media.Player;
import java.io.InputStream;

public class Lab9_GameCanvas extends GameCanvas implements Runnable {
	private static final int FRAME_DELAY = 50;	//20fps
	private static final int INPUT_DELAY = 2; 	//delay checking key input
	private boolean      blnRunning;          	//running stage2 game loop
	private boolean      blnRunning2;	  	//running stage1 game loop
	private boolean      blnGameStart;        	//running game start
	private boolean      blnStage1;			//running stage1 title
	private boolean      blnStage2;			//running stage2 title
	private boolean      blnEnd;			//running ending
	private boolean      blnEnd2;			//running thank you
	private boolean      blngameover;		//running game over
	private boolean      blnfireopen;		//check fire is open
	private boolean      blnMFire;			//check sprMFire fire open
	private boolean      blnBFire;			//check sprBFire fire open
	private boolean      blnEFire;			//check sprEFire fire open
	private boolean      blnFFire;			//check sprFFire fire open
	private boolean      blnFire;			//check sprFire fire open
	private Lab9_MIDlet  parent;                //remember the called Lab9_MIDlet
	private LayerManager lmgr;                  //the only one layer manager
	private Sprite       sprgameover,sprending,sprending2,sprHP,sprBossHP,sprBoss2HP,sprStart,sprStage1,sprStage2, sprMap,sprMap2, sprPlane,sprBoss,sprFBoss,sprEt0,sprEt1,sprEt2,sprEt3,sprEt4,sprEt5,sprEt6,sprUfo0,sprUfo1,sprUfo2,sprUfo3,sprUfo4,sprUfo5, sprMac0, sprMac1, sprMac2, sprMac3, sprMac4, sprFire0, sprFire1, sprFire2, sprFire3, sprFire4, sprFire5, sprFire6, sprFire7, sprFire8, sprFire9,sprCFire0,sprCFire1,sprCFire2,sprCFire3,sprCFire4,sprCFire5,sprCFire6,sprCFire7,sprCFire8,sprCFire9,sprBFire0,sprBFire1,sprBFire2,sprBFire3,sprBFire4,sprBFire5,sprBFire6,sprBFire7,sprBFire8,sprBFire9;     //2 game characters (layers)
	private int[]        intSeq       = {1};
	private int[]        intSeq2       = {0,1,1,1,1,1,1,2};				//all enemy frame sequence
	private int[]        intSeqhp     = {0,1,2,3,4,5,6,7,8,9,10};			//hp sequence
	private Sprite[]     sprFire;							//array of sprFire
	private Sprite[]     sprCFire;							//array of sprCFire
	private Sprite[]     sprMFire;							//array of sprMFire
        private Sprite[]     sprBFire;							//array of sprBFire
	private Sprite[]     sprEFire;							//array of sprEFire
	private Sprite[]     sprFFire;							//array of sprFFire
	private int          intScore     = 0;      					//game score
	private int          intHighscore = 0;						//game high score
	private int          intDirection = 1;      					//control the sprUfo0
	private int          intDirection2= 1;						//control the sprUfo1
	private int          intDirection3= 1;						//control the sprUfo2
	private int          intEtDirection = 1;					//control the sprEt0~sprEt5
	private int          intFBossDirection= 1;					//control the sprFBoss
	private int          intGameDelay     = 0;					//control the game delay
	private int          intBossDirection= 0;					//control the sprBoss
	private int          intFire      = 0;						//control different fire to shot
	private int          intCFire     = 0;
        private int          intMFire     = 0;
	private int          intBFire     = 0;
	private int          intEFire     = 0;
	private int          intFFire     = 0;
	private int          intHit       = 0;						//check sprUfo0~5 number of hit
	private int          intHit2      = 0;
	private int          intHit3      = 0;
	private int          intHit4      = 0;
	private int          intHit5      = 0;
	private int          intHit6      = 0;
	private int          bintEtHit0    = 0;						//check sprEt0~5 number of hit
	private int          bintEtHit1    = 0;
	private int          bintEtHit2    = 0;
	private int          bintEtHit3    = 0;
	private int          bintEtHit4    = 0;
	private int          bintEtHit5    = 0;
	private int          intMacHit0   = 0;						//check sprMac0~4 number of hit
	private int          intMacHit1   = 0;
	private int          intMacHit2   = 0;
	private int          intMacHit3   = 0;
	private int          intMacHit4   = 0;
	private int          intBossHit   = 0;						//check sprBoss number of hit
	private int          intFBossHit  = 0;						//check sprFBoss number of hit
	private int          isHit        = 0;						//check sprUfo0~5 hitted
	private int	     isHit2       = 0;
	private int          isHit3       = 0;
	private int          isHit4       = 0;
	private int          isHit5       = 0;
	private int          isHit6       = 0;
	private int          isMacHit0    = 0;						//check sprMac0~4 hitted
	private int          isMacHit1    = 0;
	private int          isMacHit2    = 0;
	private int          isMacHit3    = 0;
	private int          isMacHit4    = 0;
	private int          bisEtHit0     = 0;						//check sprEt0~5 hitted
	private int          bisEtHit1     = 0;
	private int          bisEtHit2     = 0;
	private int          bisEtHit3     = 0;
	private int          bisEtHit4     = 0;
	private int          bisEtHit5     = 0;
	private int          isBossHit    = 0;						//check sprBoss hitted
	private int          isFBossHit   = 0;						//check sprFBoss hitted
	private int          BossHitPoint = 0;						//Boss hit point
	private int          BossHitPoint2= 0;						//FBoss hit point
	private int          BossFire     = 0;						//control different fire to shot
	private int          FBossFire    = 0;						//control different fire to shot
	private int          position     = 0;						//check boss position
	private int          position2    = 0;						//check fboss position
	private int          bossmove     = 0;						//check boss move
	private int          GameEndDelay = 0;						//game end delay
	private int          GameEndDelay2= 0;						//game end delay2
	private int          planthp      = 0;						//user plant hit point
	private int          UfoFire0      = 0;						//control different fire to shot					
	private int          UfoFire1      = 0;
	private int          UfoFire2      = 0;
	private int          UfoFire3      = 0;
	private int          UfoFire4      = 0;
	private int          UfoFire5      = 0;
	private int          MacFire0      = 0;						//control different fire to shot
	private int          MacFire1      = 0;
	private int          MacFire2      = 0;
	private int          MacFire3      = 0;
	private int          MacFire4      = 0;
	private int          EtFire0      = 0;						//control different fire to shot
	private int          EtFire1      = 0;
	private int          EtFire2      = 0;
	private int          EtFire3      = 0;
	private int          EtFire4      = 0;
	private int          EtFire5      = 0;
	private Player plyrBgMusic, plyrCrash, plyrBgMusic2;				//game music

	public Lab9_GameCanvas(Lab9_MIDlet parent) {
		super(true);  //Suppress key event for game keys
		this.parent = parent;
		lmgr = new LayerManager();
		lmgr.setViewWindow( 0, 0, this.getWidth(), this.getHeight() );
		blnRunning = false;							//all boolean false,no contain game start
		blnGameStart = true;
		blnStage1 = false;
		blnStage2 = false;
		blnRunning2= false;
		blnEnd    =  false;
		blnEnd2   =  false;
		blngameover= false;
		blnfireopen= false;
		blnMFire  =  false;
		blnBFire  =  false;
		blnEFire  =  false;
		blnFFire  =  false;
		
		Thread t = new Thread(this);
		t.start();
	}

	public void run() {
		Graphics    gs = getGraphics();         
		Image       imgFFire, imgEFire,imgBFire,imgMFire,imggameover,imgending,imgending2,imgHP,imgStart,imgStage1,imgStage2, imgMap,imgMap2,imgEt0, imgPlane, imgFire,imgBoss,imgFBoss, imgUfo0, imgMac0, imgCFire;  //temporary images for creating sprites
		int         intDelay     = 0;           //delay counter for game key input
		int         intX         = 0;           //corner-point (x) of game world
		int         intY         = 0;           //corner-point (y) of game world
		int         intDelta     = 1;           //moving step of game world
		InputStream ins;                        //audio file

		try {
			ins         = getClass().getResourceAsStream("round1.mid");
			plyrBgMusic = Manager.createPlayer( ins, "audio/midi" );
			plyrBgMusic.setLoopCount(-1);
			plyrBgMusic.prefetch();
			ins         = getClass().getResourceAsStream("round2.mid");
			plyrBgMusic2 = Manager.createPlayer( ins, "audio/midi" );
			plyrBgMusic2.setLoopCount(-1);
			plyrBgMusic2.prefetch();
			//plyrBgMusic.start();
			ins       = getClass().getResourceAsStream("crash.wav");
			plyrCrash = Manager.createPlayer( ins, "audio/X-wav" );
			plyrCrash.prefetch();
			
			imggameover=Image.createImage("/gameover.png");				//all of photo
			imgending = Image.createImage("/ending.png");
			imgending2= Image.createImage("/ending2.png");
			imgEt0 = Image.createImage("/et.png");
			imgHP = Image.createImage("/hp2.png");
			imgUfo0 = Image.createImage("/ufo3.png");
			imgMac0 = Image.createImage("/ufo1.png");
			imgFire = Image.createImage("/weapon.png");
			imgMFire = Image.createImage("/weapon3.png");
			imgBFire = Image.createImage("/weapon4.png");
			imgEFire = Image.createImage("/weapon5.png");
			imgFFire = Image.createImage("/weapon6.png");
			imgMap = Image.createImage("/background.png");
			imgMap2 = Image.createImage("/space.png");
			imgPlane = Image.createImage("/airplant1.png");
			imgBoss = Image.createImage("/boss.png");
			imgFBoss = Image.createImage("/finalboss.png");
			imgCFire = Image.createImage("/weapon2.png");
			imgStart = Image.createImage("/index.png");
			imgStage1 = Image.createImage("/stage.png");
			imgStage2 = Image.createImage("/stage2.png");
			sprFire = new Sprite[10];
			for (int i=0; i<sprFire.length; i++) {					//for loop for all fire
     				sprFire[i] = new Sprite(imgFire,10,25);
				sprFire[i].setPosition(-50,10);      
   			}
			sprCFire = new Sprite[10];
			for (int i=0; i<sprCFire.length; i++) {
     				sprCFire[i] = new Sprite(imgCFire,14,15);
				sprCFire[i].setPosition(-50,10);      
   			}
			sprMFire = new Sprite[20];
			for (int i=0; i<sprMFire.length; i++) {
     				sprMFire[i] = new Sprite(imgMFire,10,10);
				sprMFire[i].setPosition(-50,10);      
   			}
			sprBFire = new Sprite[10];
			for (int i=0; i<sprBFire.length; i++) {
     				sprBFire[i] = new Sprite(imgBFire,10,20);
				sprBFire[i].setPosition(-50,10);      
   			}
			sprEFire = new Sprite[10];
			for (int i=0; i<sprEFire.length; i++) {
     				sprEFire[i] = new Sprite(imgEFire,14,16);
				sprEFire[i].setPosition(-50,10);      
   			}
			sprFFire = new Sprite[10];
			for (int i=0; i<sprFFire.length; i++) {
     				sprFFire[i] = new Sprite(imgFFire,15,22);
				sprFFire[i].setPosition(-50,10);      
   			}
			sprgameover=new Sprite(imggameover,240,291);
			sprgameover.setPosition(0,0);
			sprgameover.setVisible(false);
			sprending = new Sprite(imgending,240,291);
			sprending.setPosition(0,0);
			sprending.setVisible(false);
			sprending2 = new Sprite(imgending2,240,291);
			sprending2.setPosition(0,0);
			sprending2.setVisible(false);
			sprHP = new Sprite(imgHP, 100,12);
			sprHP.setFrameSequence(intSeqhp);
			sprHP.setPosition(140,279);
			sprBossHP = new Sprite(imgHP, 100,12);
			sprBossHP.setFrameSequence(intSeqhp);
			sprBossHP.setPosition(140,12);
			sprBossHP.setVisible(false);
			sprBoss2HP = new Sprite(imgHP, 100,12);
			sprBoss2HP.setFrameSequence(intSeqhp);
			sprBoss2HP.setPosition(140,12);
			sprBoss2HP.setVisible(false);
			sprBoss = new Sprite(imgBoss, 60,42);
			sprBoss.setPosition(-40,-40);
			sprPlane = new Sprite( imgPlane, 42, 42 );
			sprPlane.setFrameSequence(intSeq2);
			sprPlane.setPosition(99, 240);
			sprEt0 = new Sprite( imgEt0, 42,42);
			sprEt0.setFrameSequence(intSeq2);
			sprEt0.setPosition(40,-40);
			sprEt1 = new Sprite( imgEt0, 42,42);
			sprEt1.setFrameSequence(intSeq2);
			sprEt1.setPosition(70,-40);
			sprEt2 = new Sprite( imgEt0, 42,42);
			sprEt2.setFrameSequence(intSeq2);
			sprEt2.setPosition(100,-40);
			sprEt3 = new Sprite( imgEt0, 42,42);
			sprEt3.setFrameSequence(intSeq2);
			sprEt3.setPosition(130,-40);
			sprEt4 = new Sprite( imgEt0, 42,42);
			sprEt4.setFrameSequence(intSeq2);
			sprEt4.setPosition(160,-40);
			sprEt5 = new Sprite( imgEt0, 42,42);
			sprEt5.setFrameSequence(intSeq2);
			sprEt5.setPosition(190,-40);
			sprUfo0 = new Sprite( imgUfo0, 42,42);
			sprUfo0.setFrameSequence(intSeq2);
			sprUfo0.setPosition(-40,-20);
			sprUfo1 = new Sprite( imgUfo0, 42,42);
			sprUfo1.setFrameSequence(intSeq2);
			sprUfo1.setPosition(-40,-20);
			sprUfo2 = new Sprite( imgUfo0, 42,42);
			sprUfo2.setFrameSequence(intSeq2);
			sprUfo2.setPosition(-40,-20);
			sprUfo3 = new Sprite( imgUfo0, 42,42);
			sprUfo3.setFrameSequence(intSeq2);
			sprUfo3.setPosition(250,-20);
			sprUfo4 = new Sprite( imgUfo0, 42,42);
			sprUfo4.setFrameSequence(intSeq2);
			sprUfo4.setPosition(250,-20);
			sprUfo5 = new Sprite( imgUfo0, 42,42);
			sprUfo5.setFrameSequence(intSeq2);
			sprUfo5.setPosition(250,-20);
			sprMac0 = new Sprite( imgMac0, 42,42);
			sprMac0.setFrameSequence(intSeq2);
			sprMac0.setPosition(-40,-20);
			sprMac1 = new Sprite( imgMac0, 42,42);
			sprMac1.setFrameSequence(intSeq2);
			sprMac1.setPosition(-40,-20);
			sprMac2 = new Sprite( imgMac0, 42,42);
			sprMac2.setFrameSequence(intSeq2);
			sprMac2.setPosition(-40,-20);
			sprMac3 = new Sprite( imgMac0, 42,42);
			sprMac3.setFrameSequence(intSeq2);
			sprMac3.setPosition(-40,-20);
			sprMac4 = new Sprite( imgMac0, 42,42);
			sprMac4.setFrameSequence(intSeq2);
			sprMac4.setPosition(-40,-20);
			sprStart = new Sprite(imgStart, 240,291);
			sprStart.setPosition(0,0);
			sprStage1 = new Sprite(imgStage1, 240,291);
			sprStage1.setPosition(0,0);
			sprStage2 = new Sprite(imgStage2, 240,291);
			sprStage2.setPosition(0,0);
			sprStage2.setVisible(false);
			sprMap = new Sprite(imgMap);
			sprMap.setPosition(0, -1148);
			sprMap2 = new Sprite(imgMap2);
			sprMap2.setPosition(0,-1148);
			sprMap2.setVisible(false);
			

			lmgr.append(sprStart);
			lmgr.append(sprStage1);
			lmgr.append(sprStage2);
			lmgr.append(sprending);
			lmgr.append(sprending2);
			lmgr.append(sprgameover);
			lmgr.append(sprBossHP);
			lmgr.append(sprBoss2HP);
			lmgr.append(sprHP);
			for (int j=0; j<sprFire.length; j++) {
      				lmgr.append(sprFire[j]);      
   			}
			for (int j=0; j<sprCFire.length; j++) {
      				lmgr.append(sprCFire[j]);      
   			}
			for (int j=0; j<sprMFire.length; j++) {
      				lmgr.append(sprMFire[j]);      
   			}
			for (int j=0; j<sprBFire.length; j++) {
      				lmgr.append(sprBFire[j]);      
   			}
			for (int j=0; j<sprEFire.length; j++) {
      				lmgr.append(sprEFire[j]);      
   			}
			for (int j=0; j<sprFFire.length; j++) {
      				lmgr.append(sprFFire[j]);      
   			}
			lmgr.append(sprFire0);
			lmgr.append(sprFire1);
			lmgr.append(sprFire2);
			lmgr.append(sprFire3);
			lmgr.append(sprFire4);
			lmgr.append(sprFire5);
			lmgr.append(sprFire6);
			lmgr.append(sprFire7);
			lmgr.append(sprFire8);
			lmgr.append(sprFire9);
			lmgr.append(sprPlane);
			lmgr.append(sprEt0);
			lmgr.append(sprEt1);
			lmgr.append(sprEt2);
			lmgr.append(sprEt3);
			lmgr.append(sprEt4);
			lmgr.append(sprEt5);
			lmgr.append(sprUfo0);
			lmgr.append(sprUfo1);
			lmgr.append(sprUfo2);
			lmgr.append(sprUfo3);
			lmgr.append(sprUfo4);
			lmgr.append(sprUfo5);
			lmgr.append(sprMac0);
			lmgr.append(sprMac1);
			lmgr.append(sprMac2);
			lmgr.append(sprMac3);
			lmgr.append(sprMac4);
			lmgr.append(sprBoss);
			lmgr.append(sprFBoss);
			lmgr.append(sprMap);
			lmgr.append(sprMap2);
			
		} catch(Exception e) {
		}
		gs.setColor(255, 255, 255);
		gs.fillRect(0, 0, this.getWidth(), this.getHeight());
		lmgr.paint(gs, 0, 0);
		gs.setColor(255, 255, 255);
		gs.drawString("Score: "+intScore, 0,0, Graphics.TOP|Graphics.LEFT);
		gs.drawString("High Score: "+intHighscore, 150,0, Graphics.TOP|Graphics.LEFT);


		flushGraphics();  //refresh the device's display
		while(blnGameStart) {						//game start
				intDelay = 0;
				checkGameKey2();  				//detect key in separate method
				lmgr.setViewWindow(intX, intY, this.getWidth(), this.getHeight());

				lmgr.paint(gs, 0, 0);
				gs.setColor(255, 255, 255);
				flushGraphics();
				try {
				Thread.sleep(FRAME_DELAY);
			} catch(Exception e) {
			}
		}
		while(blnStage1){
          intBossDirection= 0;							//default data
          intFire      = 0;
          intCFire     = 0;
         intHit       = 0;
          intHit2      = 0;
          intHit3      = 0;
          intHit4      = 0;
          intHit5      = 0;
          intHit6      = 0;
          bintEtHit0    = 0;
          bintEtHit1    = 0;
         bintEtHit2    = 0;
          bintEtHit3    = 0;
          bintEtHit4    = 0;
          bintEtHit5    = 0;
          intMacHit0   = 0;
          intMacHit1   = 0;
          intMacHit2   = 0;
          intMacHit3   = 0;
         intMacHit4   = 0;
          intBossHit   = 0;
          intFBossHit  = 0;
          isHit        = 0;
	     isHit2       = 0;
          isHit3       = 0;
          isHit4       = 0;
          isHit5       = 0;
          isHit6       = 0;
         isMacHit0    = 0;
          isMacHit1    = 0;
          isMacHit2    = 0;
          isMacHit3    = 0;
          isMacHit4    = 0;
          bisEtHit0     = 0;
          bisEtHit1     = 0;
          bisEtHit2     = 0;
          bisEtHit3     = 0;
         bisEtHit4     = 0;
	  bisEtHit5     = 0;
          isBossHit    = 0;
          isFBossHit   = 0;
          BossFire     = 0;
         FBossFire    = 0;
          position     = 0;
          position2    = 0;
          bossmove     = 0;
          GameEndDelay = 0;
          GameEndDelay2= 0;
         UfoFire0      = 0;
         UfoFire1      = 0;
          UfoFire2      = 0;
         UfoFire3      = 0;
          UfoFire4      = 0;
         UfoFire5      = 0;
          MacFire0      = 0;
          MacFire1      = 0;
          MacFire2      = 0;
          MacFire3      = 0;
          MacFire4      = 0;
         EtFire0      = 0;
          EtFire1      = 0;
          EtFire2      = 0;
          EtFire3      = 0;
          EtFire4      = 0;
          EtFire5      = 0;
	intScore       = 0;
			sprPlane.setPosition(99, 240);
			sprBossHP.setVisible(false);
			sprBoss2HP.setVisible(false);
			sprMap.setPosition(0, -1148);
			sprMap2.setPosition(0, -1148);
			if(intGameDelay==10){					//if game delay==10 stage 1 start
				blnStage1=false;
				blnRunning2=true;
				sprStage1.setVisible(false);
				intGameDelay-=10;
			}
						try {
			plyrBgMusic.start();
			} catch(Exception e) {
			}

			intGameDelay+=1;
			lmgr.setViewWindow(intX, intY, this.getWidth(), this.getHeight());

			lmgr.paint(gs, 0, 0);
			gs.setColor(255, 255, 255);

			
			flushGraphics();
			try {
				Thread.sleep(FRAME_DELAY);
			} catch(Exception e) {
			}
		}
		while(blnRunning2) {						//stage 1 game
			intDelay++;
			if( intDelay==INPUT_DELAY ) {
				intDelay = 0;
				checkGameKey();  //detect key in separate method
			}
			checkCollision();  //detect collision in separate method
			if(intHit==2){						//check enemy hit point
				intScore+=100;	
				intHit-=2;
				isHit=1;
				sprUfo0.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intHit2==2){
				intScore+=100;
				intHit2-=2;
				isHit2=1;
				sprUfo1.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intHit3==2){
				intScore+=100;
				intHit3-=2;
				isHit3=1;
				sprUfo2.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit0==3){
				intScore+=200;
				intMacHit0-=3;
				isMacHit0=1;
				sprMac0.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit1==3){
				intScore+=200;
				intMacHit1-=3;
				isMacHit1=1;
				sprMac1.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit2==3){
				intScore+=200;
				intMacHit2-=3;
				isMacHit2=1;
				sprMac2.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit3==3){
				intScore+=200;
				intMacHit3-=3;
				isMacHit3=1;
				sprMac3.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit4==3){
				intScore+=200;
				intMacHit4-=3;
				isMacHit4=1;
				sprMac4.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			gs.setColor( 255, 255, 255 );
			gs.fillRect(0, 0, this.getWidth(), this.getHeight());
			
			if(sprMap.getY() ==-920 ||sprMap.getY() ==-720 ||sprMap.getY() ==-520 ||sprMap.getY() ==-220 ||sprMap.getY() ==0 ){
				isHit=0;
				isHit2=0;
				isHit3=0;
			}							//renew the enemy to fight user
			if(sprMap.getY() ==-860||sprMap.getY() ==-630||sprMap.getY() ==-440||sprMap.getY() ==-300||sprMap.getY() ==0){
				isMacHit0=0;
				isMacHit1=0;
				isMacHit2=0;
				isMacHit3=0;
				isMacHit4=0;
			}
			if(sprMap.getY() ==-10 & isBossHit==0){
				sprBoss.setPosition(90,-40);

			}							//map go to -10,boss show out
			if(sprMap.getY() >=-10){
				sprBossHP.setVisible(true);
			}							//map go to -10,boss hit point bar show
			if(sprBoss.getX()==90 & sprBoss.getY() <=30 & position==0){
				sprBoss.move(0,2);
			}							//boss move
			if(sprBoss.getY()==30){
			position+=1;						//control the boss stop go to bottom
			sprBoss.move( 8*intBossDirection,0 );
			BossFire +=1;
			}
			if(sprBoss.getX() < 0) {
				intBossDirection = 1;
			}
			if(sprBoss.getX() > 180) {
				intBossDirection = -1;
			}							//boss move left or right
			if(BossFire==20||BossFire==22||BossFire==24||BossFire==26||BossFire==28){
				for (int k=0; k<sprBFire.length; k++) {
					if(intBFire==k){ 
						sprBFire[k].setPosition( sprBoss.getX()+18, sprBoss.getY()+30);
						blnBFire = true;
					} 
   				}						
   
			}else if(BossFire==29){
				BossFire-=29;
			}							//boss shoot fire
			if(intBossHit==50){
				intScore+=5000;
				sprBossHP.setVisible(false);
				sprBoss.setPosition(-40,-40);
				intBossHit-=100;
				isBossHit    = 1;
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
			}							//boss dead go to stage 2
			if(isBossHit==1){
				GameEndDelay+=1;
			}							//when boss dead,game delay
			if(BossHitPoint==5){
				sprBossHP.nextFrame();
				BossHitPoint-=5;
			}
			if(GameEndDelay==10){
				try {
					plyrBgMusic.stop();
				} catch(Exception e) {
				}
				blnRunning2 = false;
				blnStage2 = true;
			}		
			if(sprMap.getY() ==-1050 & isMacHit0==0 ||sprMap.getY() ==-860 & isMacHit0==0||sprMap.getY() ==-550 & isMacHit0==0||sprMap.getY() ==-400 & isMacHit0==0||sprMap.getY() ==-260 & isMacHit0==0){
				sprMac0.setPosition(100,-30);

			}							//if map go to diffterent coordinate,sprMac0~4 move to stage
			if(sprMac0.getX()==100){
				sprMac0.move(0,4);				//sprMac0 move to bottom
				MacFire0+=1;
			}							
			if(MacFire0==7||MacFire0==9){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac0.getX()+15, sprMac0.getY()+30);
						blnMFire = true;
					} 
   				}						//if MacFire=7or9 sprMac0 will shoot fire
   
			}else if(MacFire0==30){
				MacFire0-=30;
			}
			if(sprMap.getY() ==-1020 & isMacHit1==0||sprMap.getY() ==-840 & isMacHit1==0||sprMap.getY() ==-570 & isMacHit1==0||sprMap.getY() ==-420 & isMacHit1==0||sprMap.getY() ==-300 & isMacHit1==0){
				sprMac1.setPosition(60,-30);

			}
			if(sprMac1.getX()==60){
				sprMac1.move(0,4);
				MacFire1+=1;
			}
			if(MacFire1==13||MacFire1==15){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac1.getX()+15, sprMac1.getY()+30);
						blnMFire = true;
					} 
   				}
   
			}else if(MacFire1==32){
				MacFire1-=32;
			}
			if(sprMap.getY() ==-1020 & isMacHit2==0||sprMap.getY() ==-820 & isMacHit2==0||sprMap.getY() ==-590 & isMacHit2==0||sprMap.getY() ==-440 & isMacHit2==0||sprMap.getY() ==-300 & isMacHit2==0){
				sprMac2.setPosition(140,-30);

			}
			if(sprMac2.getX()==140){
				sprMac2.move(0,4);
				MacFire2+=1;
			}
			if(MacFire2==16||MacFire2==18){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac2.getX()+15, sprMac2.getY()+30);
						blnMFire = true;
					} 
   				}
   
			}else if(MacFire2==31){
				MacFire2-=31;
			}
			if(sprMap.getY() ==-990 & isMacHit3==0||sprMap.getY() ==-800 & isMacHit3==0||sprMap.getY() ==-610 & isMacHit3==0||sprMap.getY() ==-380 & isMacHit3==0||sprMap.getY() ==-280 & isMacHit3==0){
				sprMac3.setPosition(20,-30);

			}
			if(sprMac3.getX()==20){
				sprMac3.move(0,4);
				MacFire3+=1;
			}
			if(MacFire3==12||MacFire3==14){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac3.getX()+15, sprMac3.getY()+30);
						blnMFire = true;
					} 
   				}
   
			}else if(MacFire3==28){
				MacFire3-=28;
			}
			if(sprMap.getY() ==-990 & isMacHit4==0||sprMap.getY() ==-780 & isMacHit4==0||sprMap.getY() ==-630 & isMacHit4==0||sprMap.getY() ==-360 & isMacHit4==0||sprMap.getY() ==-280 & isMacHit4==0){
				sprMac4.setPosition(180,-30);

			}
			if(sprMac4.getX()==180){
				sprMac4.move(0,4);
				MacFire4+=1;
			}
			if(MacFire4==10||MacFire4==12){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac4.getX()+15, sprMac4.getY()+30);
						blnMFire = true;
					} 
   				}
   
			}else if(MacFire4==25){
				MacFire4-=25;
			}
			if(sprMap.getY() >= -1120 & sprMap.getY() <= -950 & isHit==0 || sprMap.getY() >= -920 & sprMap.getY() <= -750 & isHit==0 || sprMap.getY() >= -720 & sprMap.getY() <= -550 & isHit==0 || sprMap.getY() >= -520 & sprMap.getY() <= -350 & isHit==0 || sprMap.getY() >= -220 & sprMap.getY() <= -50 & isHit==0 ){
			sprUfo0.move( 4*intDirection,2 );			//if map go to different coordinate,sprUfo0~2 will move
			UfoFire0+=1;
			}else{
				sprUfo0.setPosition(-40,-20);
			}
			if(sprUfo0.getX() < 0) {
				intDirection = 1;
			}
			if(sprUfo0.getX() > 198) {
				intDirection = -1;
			}							//if sprUfo0~2hit to left or right hand side, it will go another side
			if(UfoFire0==5){
				for (int k=0; k<sprCFire.length; k++) {
					if(intCFire==k){ 
						sprCFire[k].setPosition( sprUfo0.getX()+18, sprUfo0.getY()+20);
						blnfireopen = true;
					} 
   				}
   
			}else if(UfoFire0==40){
				UfoFire0-=40;
			}							//if UfoFire=40 SprUfo0 will shoot fire
	

			if(sprMap.getY() >= -1110 & sprMap.getY() <= -940 & isHit2==0 || sprMap.getY() >= -910 & sprMap.getY() <= -740 & isHit2==0 || sprMap.getY() >= -710 & sprMap.getY() <= -540 & isHit2==0 || sprMap.getY() >= -510 & sprMap.getY() <= -340 & isHit2==0 || sprMap.getY() >= -200 & sprMap.getY() <= -30 & isHit2==0 ){
			sprUfo1.move( 4*intDirection2,2 );
			UfoFire1+=1;
			}else{
				sprUfo1.setPosition(-40,-20);
			}
			if(sprUfo1.getX() < 0) {
				intDirection2 = 1;
			}
			if(sprUfo1.getX() > 198) {
				intDirection2 = -1;
			}
			if(UfoFire1==15){
				for (int k=0; k<sprCFire.length; k++) {
					if(intCFire==k){ 
						sprCFire[k].setPosition( sprUfo1.getX()+18, sprUfo1.getY()+20);
						blnfireopen = true;
					} 
   				}
   
			}else if(UfoFire1==35){
				UfoFire1-=35;
			}
			if(intScore > intHighscore){
				intHighscore=intScore;
			}
			if(sprMap.getY() >= -1100 & sprMap.getY() <= -930 & isHit3==0 || sprMap.getY() >= -900 & sprMap.getY() <= -730 & isHit3==0 || sprMap.getY() >= -700 & sprMap.getY() <= -530 & isHit3==0 || sprMap.getY() >= -500 & sprMap.getY() <= -330 & isHit3==0 || sprMap.getY() >= -180 & sprMap.getY() <= -10 & isHit3==0 ){
			sprUfo2.move( 4*intDirection3,2 );
			UfoFire2+=1;
			}else{
				sprUfo2.setPosition(-40,-20);
			}
			if(sprUfo2.getX() < 0) {
				intDirection3 = 1;
			}
			if(sprUfo2.getX() > 198) {
				intDirection3 = -1;
			}
			if(UfoFire2==25){
				for (int k=0; k<sprCFire.length; k++) {
					if(intCFire==k){ 
						sprCFire[k].setPosition( sprUfo2.getX()+18, sprUfo2.getY()+20);
						blnfireopen = true;
					} 
   				}
   
			}else if(UfoFire2==35){
				UfoFire2-=35;
			}
			for (int k=0; k<sprFire.length; k++) {
				if(sprFire[k].getX() >=0 & sprFire[k].getX() <= 230 & sprFire[k].getY() >=0){
					sprFire[k].move( 0, -12);
				}else{
					sprFire[k].setPosition(-50,10);
				}
   			}						//if fire at game screen,it will go to front
			for (int k=0; k<sprCFire.length; k++) {
				if(sprCFire[k].getX() >=0 & sprCFire[k].getX() <= 226 & sprCFire[k].getY() <=291){
					sprCFire[k].move( 0, 10);
				}else{
					sprCFire[k].setPosition(-50,10);
				}
   			}						//if fire at game screen,it will go to bottom
			for (int k=0; k<sprMFire.length; k++) {
				if(sprMFire[k].getX() >=0 & sprMFire[k].getX() <= 226 & sprMFire[k].getY() <=291){
					sprMFire[k].move( 0, 11);
				}else{
					sprMFire[k].setPosition(-50,10);
				}
   			}						//if fire at game screen,it will go to bottom
			for (int k=0; k<sprBFire.length; k++) {
				if(sprBFire[k].getX() >=0 & sprBFire[k].getX() <= 226 & sprBFire[k].getY() <=291){
					sprBFire[k].move( 0, 12);
				}else{
					sprBFire[k].setPosition(-50,10);
				}
   			}						//if fire at game screen,it will go to bottom
			if(planthp==10){
				sprHP.setFrame(10);
				sprPlane.nextFrame();
				blnRunning = false;
				blnRunning2= false;
				blngameover= true;
				try {
				plyrBgMusic.stop();
				plyrBgMusic2.stop();
				} catch(Exception e) {
				}					//user plant hit point
			}else if(planthp==1){
				sprHP.setFrame(1);
			}else if(planthp==2){
				sprHP.setFrame(2);
			}else if(planthp==3){
				sprHP.setFrame(3);
			}else if(planthp==4){
				sprHP.setFrame(4);
			}else if(planthp==5){
				sprHP.setFrame(5);
			}else if(planthp==6){
				sprHP.setFrame(6);
			}else if(planthp==7){
				sprHP.setFrame(7);
			}else if(planthp==8){
				sprHP.setFrame(8);
			}else if(planthp==9){
				sprHP.setFrame(9);
			}else{
				sprHP.setFrame(0);
			}
			if(planthp==10){
				sprPlane.nextFrame();
				blnRunning = false;
				blnRunning2= false;
				blngameover= true;
				try {
				plyrBgMusic.stop();
				plyrBgMusic2.stop();
				} catch(Exception e) {
				}
			}
			
			if(sprMap.getY() < 0) {
				sprMap.move( 0, 1);
			}						//move the map
			if(blnfireopen==true){
				intCFire+=1;
				blnfireopen=false;
				}
			if(intCFire==10){
				intCFire=0;
			}						//check fire open
			if(blnMFire==true){
				intMFire+=1;
				blnMFire=false;
				}

			if(intMFire==20){
				intMFire=0;
			}
			if(blnBFire==true){
				intBFire+=1;
				blnBFire=false;
				}

			if(intBFire==10){
				intBFire=0;
			}
			if(blnFire==true){
				intFire+=1;
				blnFire=false;
				}

			if(intFire==10){
				intFire=0;
			}


			lmgr.setViewWindow(intX, intY, this.getWidth(), this.getHeight());

			lmgr.paint(gs, 0, 0);
			gs.setColor(255, 255, 255);
			gs.drawString("Score: "+intScore, 0,0, Graphics.TOP|Graphics.LEFT);
			gs.drawString("High Score: "+intHighscore, 150,0, Graphics.TOP|Graphics.LEFT);

			
			flushGraphics();  //copy memory buffer to display
			try {
				Thread.sleep(FRAME_DELAY);
			} catch(Exception e) {
			}
		
		}
		while(blnStage2){
			for (int i=0; i<sprBFire.length; i++) {				//set all data to default
				sprBFire[i].setPosition(-50,10);      
   			}
			for (int i=0; i<sprFire.length; i++) {
				sprFire[i].setPosition(-50,10);      
   			}
          intBossDirection= 0;
          intFire      = 0;
          intCFire     = 0;
         intHit       = 0;
          intHit2      = 0;
          intHit3      = 0;
          intHit4      = 0;
          intHit5      = 0;
          intHit6      = 0;
          bintEtHit0    = 0;
          bintEtHit1    = 0;
         bintEtHit2    = 0;
          bintEtHit3    = 0;
          bintEtHit4    = 0;
          bintEtHit5    = 0;
          intMacHit0   = 0;
          intMacHit1   = 0;
          intMacHit2   = 0;
          intMacHit3   = 0;
         intMacHit4   = 0;
          intBossHit   = 0;
          intFBossHit  = 0;
          isHit        = 0;
	     isHit2       = 0;
          isHit3       = 0;
          isHit4       = 0;
          isHit5       = 0;
          isHit6       = 0;
         isMacHit0    = 0;
          isMacHit1    = 0;
          isMacHit2    = 0;
          isMacHit3    = 0;
          isMacHit4    = 0;
          bisEtHit0     = 0;
          bisEtHit1     = 0;
          bisEtHit2     = 0;
          bisEtHit3     = 0;
         bisEtHit4     = 0;
	  bisEtHit5     = 0;
          isBossHit    = 0;
          isFBossHit   = 0;
          BossFire     = 0;
         FBossFire    = 0;
          position     = 0;
          position2    = 0;
          bossmove     = 0;
          GameEndDelay = 0;
          GameEndDelay2= 0;
         UfoFire0      = 0;
         UfoFire1      = 0;
          UfoFire2      = 0;
         UfoFire3      = 0;
          UfoFire4      = 0;
         UfoFire5      = 0;
          MacFire0      = 0;
          MacFire1      = 0;
          MacFire2      = 0;
          MacFire3      = 0;
          MacFire4      = 0;
         EtFire0      = 0;
          EtFire1      = 0;
          EtFire2      = 0;
          EtFire3      = 0;
          EtFire4      = 0;
          EtFire5      = 0;
			sprPlane.setPosition(99, 240);
			sprBossHP.setVisible(false);
			sprBoss2HP.setVisible(false);
			sprMap.setPosition(0, -1148);
			sprMap2.setPosition(0, -1148);
			sprStage2.setVisible(true);
			sprMap.setVisible(false);
			sprMap2.setVisible(true);
			if(intGameDelay==10){
				blnStage2=false;
				blnRunning=true;
				sprStage2.setVisible(false);
			}
						try {
			plyrBgMusic2.start();
			} catch(Exception e) {
			}

			intGameDelay+=1;
			lmgr.setViewWindow(intX, intY, this.getWidth(), this.getHeight());

			lmgr.paint(gs, 0, 0);
			gs.setColor(255, 255, 255);

			
			flushGraphics();
			try {
				Thread.sleep(FRAME_DELAY);
			} catch(Exception e) {
			}
		}
		while(blnRunning) {
			intDelay++;
			if( intDelay==INPUT_DELAY ) {
				intDelay = 0;
				checkGameKey();  //detect key in separate method
			}
			checkCollision();  //detect collision in separate method
			if(intHit==2){							//check enemy hit point
				intScore+=100;
				intHit-=2;
				isHit=1;
				sprUfo0.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intHit2==2){
				intScore+=100;
				intHit2-=2;
				isHit2=1;
				sprUfo1.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intHit3==2){
				intScore+=100;
				intHit3-=2;
				isHit3=1;
				sprUfo2.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intHit4==2){
				intScore+=100;
				intHit4-=2;
				isHit4=1;
				sprUfo3.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intHit5==2){
				intScore+=100;
				intHit5-=2;
				isHit5=1;
				sprUfo4.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intHit6==2){
				intScore+=100;
				intHit6-=2;
				isHit6=1;
				sprUfo5.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(bintEtHit0==4){
				intScore+=300;
				bintEtHit0-=4;
				bisEtHit0=1;
				sprEt0.setPosition(40,-40);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(bintEtHit1==4){
				intScore+=300;
				bintEtHit1-=4;
				bisEtHit1=1;
				sprEt1.setPosition(70,-40);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(bintEtHit2==4){
				intScore+=300;
				bintEtHit2-=4;
				bisEtHit2=1;
				sprEt2.setPosition(100,-40);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(bintEtHit3==4){
				intScore+=300;
				bintEtHit3-=4;
				bisEtHit3=1;
				sprEt3.setPosition(130,-40);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(bintEtHit4==4){
				intScore+=300;
				bintEtHit4-=4;
				bisEtHit4=1;
				sprEt4.setPosition(160,-40);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(bintEtHit5==4){
				intScore+=300;
				bintEtHit5-=4;
				bisEtHit5=1;
				sprEt5.setPosition(190,-40);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit0==3){
				intScore+=200;
				intMacHit0-=3;
				isMacHit0=1;
				sprMac0.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit1==3){
				intScore+=200;
				intMacHit1-=3;
				isMacHit1=1;
				sprMac1.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit2==3){
				intScore+=200;
				intMacHit2-=3;
				isMacHit2=1;
				sprMac2.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit3==3){
				intScore+=200;
				intMacHit3-=3;
				isMacHit3=1;
				sprMac3.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			if(intMacHit4==3){
				intScore+=200;
				intMacHit4-=3;
				isMacHit4=1;
				sprMac4.setPosition(-40,-20);
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}
				
			}
			gs.setColor( 255, 255, 255 );
			gs.fillRect(0, 0, this.getWidth(), this.getHeight());
			
			if(sprMap2.getY() ==-1030||sprMap2.getY() ==-880||sprMap2.getY() ==-560||sprMap2.getY() ==-130){
				isHit=0;
				isHit2=0;
				isHit3=0;
				isHit4=0;
				isHit5=0;
				isHit6=0;
				
			}							//renew the enemy go fight user
			if(sprMap2.getY() ==-800||sprMap2.getY() ==-660||sprMap2.getY() ==-440||sprMap2.getY() ==-340||sprMap2.getY() ==0){
				isMacHit0=0;
				isMacHit1=0;
				isMacHit2=0;
				isMacHit3=0;
				isMacHit4=0;
			}
			if(sprMap2.getY() ==-1120||sprMap2.getY() ==-870||sprMap2.getY() ==-630){
				bisEtHit0=0;
				bisEtHit1=0;
				bisEtHit2=0;
				bisEtHit3=0;
				bisEtHit4=0;
				bisEtHit5=0;
			}
			if(sprMap2.getY() ==-10 & isFBossHit==0){
				sprFBoss.setPosition(70,-100);

			}							//final boss move
			if(sprMap2.getY() >=-10 ){
				sprBoss2HP.setVisible(true);
			}							//show hp bar
			if(sprFBoss.getX()==70 & sprFBoss.getY() <=20 & position2==0){
				sprFBoss.move(0,2);
			}
			if(sprFBoss.getY()==20){
			position2+=1;
			sprFBoss.move( 10*intFBossDirection,0 );
			FBossFire +=1;
			bossmove+=1;
			}
			if(bossmove==20||bossmove==35||bossmove==40||bossmove==52){
				intFBossDirection=intFBossDirection*-1;
			}
			if(bossmove==52){
				bossmove-=52;
			}
				
			if(sprFBoss.getX() < 0) {
				intFBossDirection = 1;
			}
			if(sprFBoss.getX() > 140) {
				intFBossDirection = -1;
			}							//control final boss
			if(FBossFire==20||FBossFire==22||FBossFire==24||FBossFire==26||FBossFire==28){
				for (int k=0; k<sprFFire.length; k++) {
					if(intFFire==k){ 
						sprFFire[k].setPosition( sprFBoss.getX()+45, sprFBoss.getY()+60);
						blnFFire = true;
					} 
   				}
   
			}else if(FBossFire==29){
				FBossFire-=29;
			}							//control final boss shoot fire
			if(intFBossHit==100){
				sprBoss2HP.setFrame(10);
				intScore+=10000;
				sprFBoss.setPosition(-150,-150);
				intFBossHit-=100;
				isFBossHit    = 1;
				try {
				plyrCrash.start();
				} catch(Exception e) {
				}						//final boss hit point
			}else if(intFBossHit<=10){
				sprBoss2HP.setFrame(0);
			}else if(intFBossHit<=20){
				sprBoss2HP.setFrame(1);
			}else if(intFBossHit<=30){
				sprBoss2HP.setFrame(2);
			}else if(intFBossHit<=40){
				sprBoss2HP.setFrame(3);
			}else if(intFBossHit<=50){
				sprBoss2HP.setFrame(4);
			}else if(intFBossHit<=60){
				sprBoss2HP.setFrame(5);
			}else if(intFBossHit<=70){
				sprBoss2HP.setFrame(6);
			}else if(intFBossHit<=80){
				sprBoss2HP.setFrame(7);
			}else if(intFBossHit<=90){
				sprBoss2HP.setFrame(8);
			}else if(intFBossHit<=100){
				sprBoss2HP.setFrame(9);
			}else{
				sprBoss2HP.setFrame(0);
			}
			if(isFBossHit==1){
				GameEndDelay2+=1;
			}
			if(GameEndDelay2==10){
				try {
					plyrBgMusic2.stop();
				} catch(Exception e) {
				}
				blnRunning = false;
				blnEnd     = true;
			}		
			if(sprMap2.getY() ==-900 & isMacHit0==0||sprMap2.getY() ==-750 & isMacHit0==0||sprMap2.getY() ==-570 & isMacHit0==0 ||sprMap2.getY() ==-470 & isMacHit0==0||sprMap2.getY() ==-180 & isMacHit0==0){
				sprMac0.setPosition(100,-30);

			}
			if(sprMac0.getX()==100){
				sprMac0.move(0,4);
				MacFire0+=1;
			}
			if(MacFire0==7||MacFire0==9){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac0.getX()+15, sprMac0.getY()+30);
						blnMFire = true;
					} 
   				}
   
			}else if(MacFire0==30){
				MacFire0-=30;
			}
			if(sprMap2.getY() ==-900 & isMacHit1==0||sprMap2.getY() ==-740 & isMacHit1==0||sprMap2.getY() ==-600 & isMacHit1==0||sprMap2.getY() ==-500 & isMacHit1==0||sprMap2.getY() ==-120 & isMacHit1==0){
				sprMac1.setPosition(60,-30);

			}
			if(sprMac1.getX()==60){
				sprMac1.move(0,4);
				MacFire1+=1;
			}
			if(MacFire1==14||MacFire1==16){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac1.getX()+15, sprMac1.getY()+30);
						blnMFire = true;
					} 
   				}
   
			}else if(MacFire1==35){
				MacFire1-=35;
			}
			if(sprMap2.getY() ==-900 & isMacHit2==0||sprMap2.getY() ==-740 & isMacHit2==0||sprMap2.getY() ==-585 & isMacHit2==0||sprMap2.getY() ==-485 & isMacHit2==0||sprMap2.getY() ==-100 & isMacHit2==0){
				sprMac2.setPosition(140,-30);

			}
			if(sprMac2.getX()==140){
				sprMac2.move(0,4);
				MacFire2+=1;
			}
			if(MacFire2==8||MacFire2==10){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac2.getX()+15, sprMac2.getY()+30);
						blnMFire = true;
					} 
   				}
   
			}else if(MacFire2==33){
				MacFire2-=33;
			}
			if(sprMap2.getY() ==-900 & isMacHit3==0||sprMap2.getY() ==-730 & isMacHit3==0||sprMap2.getY() ==-555 & isMacHit3==0||sprMap2.getY() ==-455 & isMacHit3==0||sprMap2.getY() ==-160 & isMacHit3==0){
				sprMac3.setPosition(20,-30);

			}
			if(sprMac3.getX()==20){
				sprMac3.move(0,4);
				MacFire3+=1;
			}
			if(MacFire3==19||MacFire3==21){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac3.getX()+15, sprMac3.getY()+30);
						blnMFire = true;
					} 
   				}
   
			}else if(MacFire3==31){
				MacFire3-=31;
			}
			if(sprMap2.getY() ==-900 & isMacHit4==0||sprMap2.getY() ==-730 & isMacHit4==0||sprMap2.getY() ==-540 & isMacHit4==0||sprMap2.getY() ==-440 & isMacHit4==0||sprMap2.getY() ==-140 & isMacHit4==0){
				sprMac4.setPosition(180,-30);

			}
			if(sprMac4.getX()==180){
				sprMac4.move(0,4);
				MacFire4+=1;
			}
			if(MacFire4==24||MacFire4==26){
				for (int k=0; k<sprMFire.length; k++) {
					if(intMFire==k){ 
						sprMFire[k].setPosition( sprMac4.getX()+15, sprMac4.getY()+30);
						blnMFire = true;
					} 
   				}
   
			}else if(MacFire4==36){
				MacFire4-=36;
			}
			if(intScore > intHighscore){
				intHighscore=intScore;
			}
			if(sprMap2.getY() >= -1120 & sprMap2.getY() <= -1050 & sprUfo0.getX() <= 250 & isHit==0||sprMap2.getY() >= -1000 & sprMap2.getY() <= -930 & sprUfo0.getX() <= 250 & isHit==0||sprMap2.getY() >= -690 & sprMap2.getY() <= -620 & sprUfo0.getX() <= 250 & isHit==0||sprMap2.getY() >= -300 & sprMap2.getY() <= -230 & sprUfo0.getX() <= 250 & isHit==0){
			sprUfo0.move( 4,2 );
			UfoFire0+=1; 
			}else{
				sprUfo0.setPosition(-40,-20);
			}
			if(UfoFire0==10){
				for (int k=0; k<sprCFire.length; k++) {
					if(intCFire==k){ 
						sprCFire[k].setPosition( sprUfo0.getX()+18, sprUfo0.getY()+20);
						blnfireopen = true;
					} 
   				}
   
			}else if(UfoFire0==40){
				UfoFire0-=40;
			}
			if(sprMap2.getY() >= -1110 & sprMap2.getY() <= -1040 & sprUfo1.getX() <= 250 & isHit2==0||sprMap2.getY() >= -980 & sprMap2.getY() <= -910 & sprUfo1.getX() <= 250 & isHit2==0||sprMap2.getY() >= -680 & sprMap2.getY() <= -610 & sprUfo1.getX() <= 250 & isHit2==0||sprMap2.getY() >= -260 & sprMap2.getY() <= -190 & sprUfo1.getX() <= 250 & isHit2==0){
			sprUfo1.move( 4,2 );
			UfoFire1+=1;
			}else{
				sprUfo1.setPosition(-40,-20);
			}
			if(UfoFire1==16){
				for (int k=0; k<sprCFire.length; k++) {
					if(intCFire==k){ 
						sprCFire[k].setPosition( sprUfo1.getX()+18, sprUfo1.getY()+20);
						blnfireopen = true;
					} 
   				}
   
			}else if(UfoFire1==45){
				UfoFire1-=45;
			}
			if(sprMap2.getY() >= -1100 & sprMap2.getY() <= -1030 & sprUfo2.getX() <= 250 & isHit3==0||sprMap2.getY() >= -960 & sprMap2.getY() <= -890 & sprUfo2.getX() <= 250 & isHit3==0||sprMap2.getY() >= -670 & sprMap2.getY() <= -600 & sprUfo2.getX() <= 250 & isHit3==0||sprMap2.getY() >= -220 & sprMap2.getY() <= -150 & sprUfo2.getX() <= 250 & isHit3==0){
			sprUfo2.move( 4,2 );
			UfoFire2+=1;
			}else{
				sprUfo2.setPosition(-40,-20);
			}
			if(UfoFire2==25){
				for (int k=0; k<sprCFire.length; k++) {
					if(intCFire==k){ 
						sprCFire[k].setPosition( sprUfo2.getX()+18, sprUfo2.getY()+20);
						blnfireopen = true;
					} 
   				}
   
			}else if(UfoFire2==50){
				UfoFire2-=50;
			}
			if(sprMap2.getY() >= -1120 & sprMap2.getY() <= -1050 & sprUfo3.getX() >= -40 & isHit4==0||sprMap2.getY() >= -990 & sprMap2.getY() <= -920 & sprUfo3.getX() >= -40 & isHit4==0||sprMap2.getY() >= -660 & sprMap2.getY() <= -590 & sprUfo3.getX() >= -40 & isHit4==0||sprMap2.getY() >= -280 & sprMap2.getY() <= -210 & sprUfo3.getX() >= -40 & isHit4==0){
			sprUfo3.move( -4,2 );
			UfoFire3+=1;
			}else{
				sprUfo3.setPosition(250,-20);
			}
			if(UfoFire3==20){
				for (int k=0; k<sprCFire.length; k++) {
					if(intCFire==k){ 
						sprCFire[k].setPosition( sprUfo3.getX()+18, sprUfo3.getY()+20);
						blnfireopen = true;
					} 
   				}
   
			}else if(UfoFire3==40){
				UfoFire3-=40;
			}
			if(sprMap2.getY() >= -1110 & sprMap2.getY() <= -1040 & sprUfo4.getX() >= -40 & isHit5==0||sprMap2.getY() >= -970 & sprMap2.getY() <= -900 & sprUfo4.getX() >= -40 & isHit5==0||sprMap2.getY() >= -650 & sprMap2.getY() <= -580 & sprUfo4.getX() >= -40 & isHit5==0||sprMap2.getY() >= -240 & sprMap2.getY() <= -170 & sprUfo4.getX() >= -40 & isHit5==0){
			sprUfo4.move( -4,2 );
			UfoFire4+=1;
			}else{
				sprUfo4.setPosition(250,-20);
			}
			if(UfoFire4==22){
				for (int k=0; k<sprCFire.length; k++) {
					if(intCFire==k){ 
						sprCFire[k].setPosition( sprUfo4.getX()+18, sprUfo4.getY()+20);
						blnfireopen = true;
					} 
   				}
   
			}else if(UfoFire4==40){
				UfoFire4-=40;
			}
			if(sprMap2.getY() >= -1100 & sprMap2.getY() <= -1030 & sprUfo5.getX() >= -40 & isHit6==0||sprMap2.getY() >= -950 & sprMap2.getY() <= -880 & sprUfo5.getX() >= -40 & isHit6==0||sprMap2.getY() >= -640 & sprMap2.getY() <= -570 & sprUfo5.getX() >= -40 & isHit6==0||sprMap2.getY() >= -200 & sprMap2.getY() <= -130 & sprUfo5.getX() >= -40 & isHit6==0){
			sprUfo5.move( -4,2 );
			UfoFire5+=1;
			}else{
				sprUfo5.setPosition(250,-20);
			}
			if(UfoFire5==15){
				for (int k=0; k<sprCFire.length; k++) {
					if(intCFire==k){ 
						sprCFire[k].setPosition( sprUfo5.getX()+18, sprUfo5.getY()+20);
						blnfireopen = true;
					} 
   				}
   
			}else if(UfoFire5==40){
				UfoFire5-=40;
			}
			if(sprMap2.getY() >= -1080 & sprMap2.getY() <= -910 & sprEt0.getY() <= 291 & bisEtHit0==0 ||sprMap2.getY() >= -870 & sprMap2.getY() <= -700 & bisEtHit0==0||sprMap2.getY() >= -400 & sprMap2.getY() <= -230 & bisEtHit0==0){
			sprEt0.move( 2*intEtDirection,2 );
			EtFire0+=1;
			}else{
				sprEt0.setPosition(40,-40);
			}					
			if(sprEt0.getX() < 0) {
				intEtDirection = 1;
			}
			if(sprEt0.getX() > 198) {
				intEtDirection = -1;
			}								//sprEt0~5 moving
			if(EtFire0==25){
				for (int k=0; k<sprEFire.length; k++) {
					if(intEFire==k){ 
						sprEFire[k].setPosition( sprEt0.getX()+15, sprEt0.getY()+20);
						blnEFire = true;
					} 
   				}
   
			}else if(EtFire0==50){
				EtFire0-=50;
			}
			if(sprMap2.getY() >= -1070 & sprMap2.getY() <= -900 & sprEt1.getY() <= 291 & bisEtHit1==0||sprMap2.getY() >= -860 & sprMap2.getY() <= -690 & bisEtHit1==0||sprMap2.getY() >= -320 & sprMap2.getY() <= -150 & bisEtHit1==0){
			sprEt1.move( -2*intEtDirection,2 );
			EtFire1+=1;
			}else{
				sprEt1.setPosition(70,-40);
			}
			if(sprEt1.getX() < 0) {
				intEtDirection = -1;
			}
			if(sprEt1.getX() > 198) {
				intEtDirection = 1;
			}
			if(EtFire1==25){
				for (int k=0; k<sprEFire.length; k++) {
					if(intEFire==k){ 
						sprEFire[k].setPosition( sprEt1.getX()+15, sprEt1.getY()+20);
						blnEFire = true;
					} 
   				}
   
			}else if(EtFire1==50){
				EtFire1-=50;
			}
			if(sprMap2.getY() >= -1060 & sprMap2.getY() <= -890 & sprEt2.getY() <= 291 & bisEtHit2==0||sprMap2.getY() >= -850 & sprMap2.getY() <= -680 & bisEtHit2==0||sprMap2.getY() >= -380 & sprMap2.getY() <= -210 & bisEtHit2==0){
			sprEt2.move( -3*intEtDirection,2 );
			EtFire2+=1;
			}else{
				sprEt2.setPosition(100,-40);
			}
			if(sprEt2.getX() < 0) {
				intEtDirection = -1;
			}
			if(sprEt2.getX() > 198) {
				intEtDirection = 1;
			}
			if(EtFire2==28){
				for (int k=0; k<sprEFire.length; k++) {
					if(intEFire==k){ 
						sprEFire[k].setPosition( sprEt2.getX()+15, sprEt2.getY()+20);
						blnEFire = true;
					} 
   				}
   
			}else if(EtFire2==50){
				EtFire2-=50;
			}
			if(sprMap2.getY() >= -1050 & sprMap2.getY() <= -880 & sprEt3.getY() <= 291 & bisEtHit3==0||sprMap2.getY() >= -840 & sprMap2.getY() <= -670 & bisEtHit3==0||sprMap2.getY() >= -375 & sprMap2.getY() <= -205 & bisEtHit3==0){
			sprEt3.move( 3*intEtDirection,2 );
			EtFire3+=1;
			}else{
				sprEt3.setPosition(130,-40);
			}
			if(sprEt3.getX() < 0) {
				intEtDirection = 1;
			}
			if(sprEt3.getX() > 198) {
				intEtDirection = -1;
			}
			if(EtFire3==30){
				for (int k=0; k<sprEFire.length; k++) {
					if(intEFire==k){ 
						sprEFire[k].setPosition( sprEt3.getX()+15, sprEt3.getY()+20);
						blnEFire = true;
					} 
   				}
   
			}else if(EtFire3==50){
				EtFire3-=50;
			}
			if(sprMap2.getY() >= -1040 & sprMap2.getY() <= -870 & sprEt4.getY() <= 291 & bisEtHit4==0||sprMap2.getY() >= -830 & sprMap2.getY() <= -660 & bisEtHit4==0||sprMap2.getY() >= -340 & sprMap2.getY() <= -170 & bisEtHit4==0){
			sprEt4.move( -2*intEtDirection,2 );
			EtFire4+=1;
			}else{
				sprEt4.setPosition(160,-40);
			}
			if(sprEt4.getX() < 0) {
				intEtDirection = -1;
			}
			if(sprEt4.getX() > 198) {
				intEtDirection = 1;
			}
			if(EtFire4==33){
				for (int k=0; k<sprEFire.length; k++) {
					if(intEFire==k){ 
						sprEFire[k].setPosition( sprEt4.getX()+15, sprEt4.getY()+20);
						blnEFire = true;
					} 
   				}
   
			}else if(EtFire4==50){
				EtFire4-=50;
			}
			if(sprMap2.getY() >= -1030 & sprMap2.getY() <= -860 & sprEt5.getY() <= 291 & bisEtHit5==0||sprMap2.getY() >= -820 & sprMap2.getY() <= -650 & bisEtHit5==0||sprMap2.getY() >= -335 & sprMap2.getY() <= -165 & bisEtHit5==0){
			sprEt5.move( 3*intEtDirection,2 );
			EtFire5+=1;
			}else{
				sprEt5.setPosition(190,-40);
			}
			if(sprEt5.getX() < 0) {
				intEtDirection = 1;
			}
			if(sprEt5.getX() > 198) {
				intEtDirection = -1;
			}
			if(EtFire5==37){
				for (int k=0; k<sprEFire.length; k++) {
					if(intEFire==k){ 
						sprEFire[k].setPosition( sprEt5.getX()+15, sprEt5.getY()+20);
						blnEFire = true;
					} 
   				}
   
			}else if(EtFire5==50){
				EtFire5-=50;
			}
			for (int k=0; k<sprFire.length; k++) {
				if(sprFire[k].getX() >=0 & sprFire[k].getX() <= 230 & sprFire[k].getY() >=0){
					sprFire[k].move( 0, -12);
				}else{
					sprFire[k].setPosition(-50,10);
				}
   			}
			for (int k=0; k<sprCFire.length; k++) {
				if(sprCFire[k].getX() >=0 & sprCFire[k].getX() <= 226 & sprCFire[k].getY() <=291){
					sprCFire[k].move( 0, 12);
				}else{
					sprCFire[k].setPosition(-50,10);
				}
   			}
			for (int k=0; k<sprMFire.length; k++) {
				if(sprMFire[k].getX() >=0 & sprMFire[k].getX() <= 226 & sprMFire[k].getY() <=291){
					sprMFire[k].move( 0, 11);
				}else{
					sprMFire[k].setPosition(-50,10);
				}
   			}
			for (int k=0; k<sprEFire.length; k++) {
				if(sprEFire[k].getX() >=0 & sprEFire[k].getX() <= 226 & sprEFire[k].getY() <=291){
					sprEFire[k].move( 0, 15);
				}else{
					sprEFire[k].setPosition(-50,10);
				}
   			}
			for (int k=0; k<sprFFire.length; k++) {
				if(sprFFire[k].getX() >=0 & sprFFire[k].getX() <= 226 & sprFFire[k].getY() <=291){
					sprFFire[k].move( 0, 15);
				}else{
					sprFFire[k].setPosition(-50,10);
				}
   			}
			
			if(sprMap2.getY() < 0) {
				sprMap2.move( 0, 1);
			}
			lmgr.setViewWindow(intX, intY, this.getWidth(), this.getHeight());

			lmgr.paint(gs, 0, 0);
			gs.setColor(255, 255, 255);
			gs.drawString("Score: "+intScore, 0,0, Graphics.TOP|Graphics.LEFT);
			gs.drawString("High Score: "+intHighscore, 150,0, Graphics.TOP|Graphics.LEFT);

			
			flushGraphics();  //copy memory buffer to display
			try {
				Thread.sleep(FRAME_DELAY);
			} catch(Exception e) {
			}
			if(planthp>=10){
				sprHP.setFrame(10);
				sprPlane.nextFrame();
				blnRunning = false;
				blnRunning2= false;
				blngameover= true;
				try {
				plyrBgMusic.stop();
				plyrBgMusic2.stop();
				} catch(Exception e) {
				}
			}else if(planthp==1){
				sprHP.setFrame(1);
			}else if(planthp==2){
				sprHP.setFrame(2);
			}else if(planthp==3){
				sprHP.setFrame(3);
			}else if(planthp==4){
				sprHP.setFrame(4);
			}else if(planthp==5){
				sprHP.setFrame(5);
			}else if(planthp==6){
				sprHP.setFrame(6);
			}else if(planthp==7){
				sprHP.setFrame(7);
			}else if(planthp==8){
				sprHP.setFrame(8);
			}else if(planthp==9){
				sprHP.setFrame(9);
			}else{
				sprHP.setFrame(0);
			}							//user plant hp;
			if(blnfireopen==true){					//check fire is shoot
				intCFire+=1;
				blnfireopen=false;
				}
			if(intCFire==10){
				intCFire=0;
			}
			if(blnMFire==true){
				intMFire+=1;
				blnMFire=false;
				}

			if(intMFire==20){
				intMFire=0;
			}
			if(blnEFire==true){
				intEFire+=1;
				blnEFire=false;
				}

			if(intEFire==10){
				intEFire=0;
			}
			if(blnFFire==true){
				intFFire+=1;
				blnFFire=false;
				}

			if(intFFire==10){
				intFFire=0;
			}
			if(blnFire==true){
				intFire+=1;
				blnFire=false;
				}

			if(intFire==10){
				intFire=0;
			}
		
		}
		while(blnEnd){
			sprending.setVisible(true);
			if(intGameDelay==150){
				blnEnd=false;
				blnEnd2=true;
				intGameDelay-=150;
			}
			intGameDelay+=1;
			lmgr.setViewWindow(intX, intY, this.getWidth(), this.getHeight());

			lmgr.paint(gs, 0, 0);
			gs.setColor(255, 255, 255);

			
			flushGraphics();
			try {
				Thread.sleep(FRAME_DELAY);
			} catch(Exception e) {
			}
		}
		while(blnEnd2){
			sprending.setVisible(false);
			sprending2.setVisible(true);
			if(intGameDelay==100){
				blnEnd2=false;
				blnGameStart=true;
				sprending2.setVisible(false);
				sprStart.setVisible(true);
				intGameDelay-=100;
			}
			intGameDelay+=1;
			lmgr.setViewWindow(intX, intY, this.getWidth(), this.getHeight());

			lmgr.paint(gs, 0, 0);
			gs.setColor(255, 255, 255);
			gs.drawString("Your Score: "+intScore, 50,20, Graphics.TOP|Graphics.LEFT);
			//gs.drawString("High Score: "+intHighscore, 150,0, Graphics.TOP|Graphics.LEFT);

			
			flushGraphics();
			try {
				Thread.sleep(FRAME_DELAY);
			} catch(Exception e) {
			}
		}
		while(blngameover){
			//sprending.setVisible(false);
			sprgameover.setVisible(true);
			if(intGameDelay==50){
				blngameover=false;
				blnGameStart=true;
				sprStart.setVisible(true);
				intGameDelay-=50;
				
			}
			intGameDelay+=1;
			lmgr.setViewWindow(intX, intY, this.getWidth(), this.getHeight());

			lmgr.paint(gs, 0, 0);
			gs.setColor(255, 255, 255);
			gs.drawString("Your Score: "+intScore, 70,120, Graphics.TOP|Graphics.LEFT);

			
			flushGraphics();
			try {
				Thread.sleep(FRAME_DELAY);
			} catch(Exception e) {
			}
		}
	}

	public void checkGameKey() {
		int intKey = getKeyStates();
		if(sprPlane.getY() >= 0){
			if( (intKey & GameCanvas.UP_PRESSED) != 0 ) {
				sprPlane.move(0, -4);
			}
		}
		if(sprPlane.getY() <= 249){ 
			if( (intKey & GameCanvas.DOWN_PRESSED) != 0 ) {
				sprPlane.move(0, 4);
			}
		} 
		if(sprPlane.getX() >= 0){
			if( (intKey & GameCanvas.LEFT_PRESSED) != 0 ) {
				sprPlane.move(-4, 0);
			} 
		}
		if(sprPlane.getX() < 198){
			if( (intKey & GameCanvas.RIGHT_PRESSED) != 0 ) {
				sprPlane.move(4, 0);
			}
		}
		for (int k=0; k<sprFire.length; k++) {
			if(intFire==k){ 
				if( (intKey & GameCanvas.GAME_A_PRESSED) != 0 ) {
					sprFire[k].setPosition(sprPlane.getX()+16, sprPlane.getY()-15);
					blnFire = true;
				}
			} 
   		}



	}
	public void checkGameKey2() {
		int intKey2 = getKeyStates();
			if( (intKey2 & GameCanvas.GAME_B_PRESSED) != 0 ) {
			sprStart.setVisible(false);
			blnGameStart=false;
			blnStage1=true;
			}
	}

	public void checkCollision() {
		if( sprUfo0.collidesWith(sprPlane, true) ||sprUfo1.collidesWith(sprPlane, true)||sprUfo2.collidesWith(sprPlane, true)||sprMac0.collidesWith(sprPlane, true)||sprMac1.collidesWith(sprPlane, true)||sprMac2.collidesWith(sprPlane, true)||sprMac3.collidesWith(sprPlane, true)||sprMac4.collidesWith(sprPlane, true)||sprEt0.collidesWith(sprPlane, true)||sprEt1.collidesWith(sprPlane, true)||sprEt2.collidesWith(sprPlane, true)||sprEt3.collidesWith(sprPlane, true)||sprEt4.collidesWith(sprPlane, true)||sprEt5.collidesWith(sprPlane, true)) {
			sprPlane.nextFrame();
			blnRunning = false;
			blnRunning2= false;
			blngameover= true;
			try {
			plyrBgMusic.stop();
			plyrBgMusic2.stop();
			} catch(Exception e) {
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprUfo0, true) ) {
				sprFire[k].setPosition(-50,10);
				intHit++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprUfo1, true) ) {
				sprFire[k].setPosition(-50,10);
				intHit2++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprUfo2, true) ) {
				sprFire[k].setPosition(-50,10);
				intHit3++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprUfo3, true) ) {
				sprFire[k].setPosition(-50,10);
				intHit4++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprUfo4, true) ) {
				sprFire[k].setPosition(-50,10);
				intHit5++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprUfo5, true) ) {
				sprFire[k].setPosition(-50,10);
				intHit6++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprMac0, true) ) {
				sprFire[k].setPosition(-50,10);
				intMacHit0++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprMac1, true) ) {
				sprFire[k].setPosition(-50,10);
				intMacHit1++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprMac2, true) ) {
				sprFire[k].setPosition(-50,10);
				intMacHit2++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprMac3, true) ) {
				sprFire[k].setPosition(-50,10);
				intMacHit3++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprMac4, true) ) {
				sprFire[k].setPosition(-50,10);
				intMacHit4++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprBoss, true) ) {
				sprFire[k].setPosition(-50,10);
				intBossHit++;
				BossHitPoint++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprEt0, true) ) {
				sprFire[k].setPosition(-50,10);
				bintEtHit0++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprEt1, true) ) {
				sprFire[k].setPosition(-50,10);
				bintEtHit1++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprEt2, true) ) {
				sprFire[k].setPosition(-50,10);
				bintEtHit2++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprEt3, true) ) {
				sprFire[k].setPosition(-50,10);
				bintEtHit3++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprEt4, true) ) {
				sprFire[k].setPosition(-50,10);
				bintEtHit4++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprEt5, true) ) {
				sprFire[k].setPosition(-50,10);
				bintEtHit5++;
			}
		}
		for (int k=0; k<sprFire.length; k++){
			if( sprFire[k].collidesWith(sprFBoss, true) ) {
				sprFire[k].setPosition(-50,10);
				intFBossHit++;
				BossHitPoint2++;
			}
		}
		for (int k=0; k<sprCFire.length; k++){
			if( sprCFire[k].collidesWith(sprPlane, true) ) {
				sprCFire[k].setPosition(-50,10);
				planthp++;
			}
		}
		for (int k=0; k<sprMFire.length; k++){
			if( sprMFire[k].collidesWith(sprPlane, true) ) {
				sprMFire[k].setPosition(-50,10);
				planthp++;
			}
		}
		for (int k=0; k<sprBFire.length; k++){
			if( sprBFire[k].collidesWith(sprPlane, true) ) {
				sprBFire[k].setPosition(-50,10);
				planthp++;
			}
		}
		for (int k=0; k<sprEFire.length; k++){
			if( sprEFire[k].collidesWith(sprPlane, true) ) {
				sprEFire[k].setPosition(-50,10);
				planthp++;
			}
		}
		for (int k=0; k<sprFFire.length; k++){
			if( sprFFire[k].collidesWith(sprPlane, true) ) {
				sprFFire[k].setPosition(-50,10);
				planthp++;
			}
		}




	}

	public void stop() {
		try {
			plyrBgMusic.stop();
		} catch(Exception e) {
		}
		blnRunning = false;
	}
}
